// MessageHook.h

#pragma once

using namespace System;
using namespace System::Windows::Forms;

namespace MessageHook {

	public ref class MessageBoxInfo
	{
	public:
		IntPtr Hwnd;
		String^ Text;
		String^ Caption;
		int MbType;

		MessageBoxInfo(HWND hwnd, LPCWSTR text, LPCWSTR cap, int mbtype) :
			Hwnd(static_cast<IntPtr>(hwnd)), Text(gcnew String(text)), Caption(gcnew String(cap)), MbType(mbtype)
		{
		}
	};

	public ref class HookMonkey
	{
		typedef Converter<MessageBoxInfo^, DialogResult>^ handler_t;

	internal:
		static handler_t s_handler;

	public:
		static void Install(handler_t handler);
	};
}
